create or replace
PROCEDURE ETL_RESULTDES
                     (P_DTINI      IN DATE,
                      P_DTFINA     IN DATE)
IS
  V_DTFIM           DATE;
  V_DTINI           DATE;
  V_NRRESULTDES     INT;-- ETLRESULTDES.NRRESULTDES%TYPE;
  V_DTMES           VARCHAR2(07);
  V_DTANO           VARCHAR2(04);
  V_TIPOFATU        VARCHAR2(30);
  V_BIM             VARCHAR2(02);
  V_TRI             VARCHAR2(02);
  V_SEM             varchar2(02);
  V_CLIENTE         VARCHAR2(21);
  V_QTAPROP         FLOAT(20);
  V_QTPLANE         FLOAT(20);
  V_PERCERRO        FLOAT;
  V_QTTOTALATIVOPER FLOAT;
  V_QTERROCTOTAL    FLOAT;
  V_QTTOTALATIV     FLOAT;
  V_QTERROCTESTE    FLOAT := 0;
  V_QTERROCCLIENTE  FLOAT := 0;
  V_QTPERCERROCONC  FLOAT := 0;
  
BEGIN
    BEGIN
      SELECT NVL(MAX(TO_NUMBER(NRRESULTDES)),0)
        INTO V_NRRESULTDES
        FROM ETLRESULTDES;
      EXCEPTION
        WHEN OTHERS THEN
             V_NRRESULTDES := 0;
    END;
    V_DTMES  :=  TO_CHAR(P_DTINI,'MM');
    V_DTANO  :=  TO_CHAR(P_DTINI,'YYYY');
    BEGIN
       DELETE FROM ETLRESULTDES
       WHERE  ANRESULTDES >= V_DTANO
          AND MERESULTDES >= V_DTMES;
    END;
    V_DTFIM := LAST_DAY(V_DTINI);
    V_DTINI := P_DTINI;
    WHILE (V_DTINI  <=  P_DTFINA) LOOP
          V_DTFIM := LAST_DAY( V_DTINI);
          FOR C_ETL IN
              (SELECT
                      P.CDOPERRESP, S.NRSOLISERV, P.CDPROCESSO, T.CDASSUNTO,
                      S.CDCLIENTE, FU.CDEQUIPETRAB, T.CDFILIAL, T.NRTAREFA, FU.CDFUNC
                FROM
                      APROATIVTARE A, PLANATIVTARE P, TAREFA T, SOLISERV S,
                      PROCESSO PR, ASSUNTO AU, CLIENTE CL, OPERADOR OP,
                      FUNCIONARIO FU
               WHERE
                      A.CDFILIAL     = P.CDFILIAL
                  AND A.NRTAREFA     = P.NRTAREFA
                  AND A.NRPLATIVTARE = P.NRPLATIVTARE
                  AND P.CDOPERRESP   = OP.CDOPERADOR
                  AND P.CDFILIAL     = T.CDFILIAL
                  AND P.NRTAREFA     = T.NRTAREFA
                  AND T.CDFILIAL     = S.CDFILIAL(+)
                  AND T.NRSOLISERV   = S.NRSOLISERV(+)
                  AND T.CDPROCESSO   = PR.CDPROCESSO(+)
                  AND T.CDASSUNTO    = AU.CDASSUNTO
                  AND S.CDCLIENTE    = CL.CDCLIENTE(+)
                  AND OP.CDFUNC      = FU.CDFUNC
                  AND (P.CDPROCESSO = 11045 OR
                       P.CDPROCESSO = 11054 OR
                       P.CDPROCESSO = 10196 OR
                       P.CDPROCESSO = 10712 OR
                       P.CDPROCESSO = 10706 OR
                       P.CDPROCESSO = 11077 OR
                       P.CDPROCESSO = 11080)
                  AND ((DTHIAPATIVTA BETWEEN V_DTINI AND V_DTFIM)
                     OR(DTINPATIVTAR BETWEEN V_DTINI AND V_DTFIM)
                     OR(DTCONATIVTAR BETWEEN V_DTINI AND V_DTFIM))
              GROUP BY
                      P.CDOPERRESP, S.NRSOLISERV, P.CDPROCESSO, T.CDASSUNTO,
                      S.CDCLIENTE, FU.CDEQUIPETRAB, T.CDFILIAL, T.NRTAREFA, FU.CDFUNC)
          LOOP

                BEGIN
                   SELECT COUNT(*)
                     INTO V_QTTOTALATIVOPER
                     FROM PLANATIVTARE PL, TAREFA T, OPERADOR OP, FUNCIONARIO FU, ASSUNTO AU
                    WHERE TRUNC(PL.DTCONATIVTAR) BETWEEN V_DTINI AND V_DTFIM
                      AND PL.CDFILIAL       = T.CDFILIAL
                      AND PL.NRTAREFA       = T.NRTAREFA
                      AND PL.CDOPERRESP     = OP.CDOPERADOR
                      AND OP.CDFUNC         = FU.CDFUNC
                      AND T.CDASSUNTO       = AU.CDASSUNTO
                      AND PL.CDOPERRESP     = C_ETL.CDOPERRESP
                      AND FU.CDEQUIPETRAB   = C_ETL.CDEQUIPETRAB
                      AND (PL.CDPROCESSO = 11045 OR PL.CDPROCESSO = 11054 OR PL.CDPROCESSO = 10196 
                           OR PL.CDPROCESSO = 10712 OR PL.CDPROCESSO = 10706 OR PL.CDPROCESSO = 11077 OR PL.CDPROCESSO = 11080);
                EXCEPTION
                     WHEN OTHERS THEN
                          V_QTTOTALATIVOPER := 0;
              END;

              BEGIN
                   SELECT COUNT(*)
                     INTO V_QTTOTALATIV --QNTDE TOTAL DE ATIVIDADES
                     FROM PLANATIVTARE PL, TAREFA T, OPERADOR OP, FUNCIONARIO FU, ASSUNTO AU
                    WHERE TRUNC(PL.DTCONATIVTAR) BETWEEN V_DTINI AND V_DTFIM
                      AND PL.CDFILIAL       = T.CDFILIAL
                      AND PL.NRTAREFA       = T.NRTAREFA
                      AND PL.CDOPERRESP     = OP.CDOPERADOR
                      AND OP.CDFUNC         = FU.CDFUNC
                      AND T.CDASSUNTO       = AU.CDASSUNTO
                      AND PL.CDFILIAL    (+)= C_ETL.CDFILIAL
                      AND PL.CDOPERRESP  (+)= C_ETL.CDOPERRESP
                      AND PL.CDPROCESSO  (+)= C_ETL.CDPROCESSO
                      AND T.NRSOLISERV   (+)= C_ETL.NRSOLISERV
                      AND T.CDASSUNTO    (+)= C_ETL.CDASSUNTO
                      AND T.NRTAREFA     (+)= C_ETL.NRTAREFA
                      AND OP.CDFUNC = C_ETL.CDFUNC;
                EXCEPTION
                     WHEN OTHERS THEN
                          V_QTTOTALATIV := 0;
              END;
              
              
                  
              BEGIN
                   SELECT COUNT(*)
                     INTO V_QTERROCCLIENTE   --QNTDE DE ERRO CONCLUDO NO CLIENTE
                     FROM PLANATIVTARE PL, TAREFA T, OPERADOR OP    --, FUNCIONARIO FU
                    WHERE TRUNC(PL.DTCONATIVTAR) BETWEEN V_DTINI AND V_DTFIM
                      AND IDSITATIVTAR     = 'C'
                      AND PL.CDFILIAL      = T.CDFILIAL
                      AND PL.NRTAREFA      = T.NRTAREFA
                      AND PL.CDFILIAL   (+)= C_ETL.CDFILIAL
                      AND PL.CDOPERRESP (+)= C_ETL.CDOPERRESP
                      AND PL.CDPROCESSO (+)= C_ETL.CDPROCESSO
                      AND PL.CDPROCESSO    = 10196
                      AND T.NRSOLISERV(+) = C_ETL.NRSOLISERV
                      AND T.CDASSUNTO (+) = C_ETL.CDASSUNTO
                      AND OP.CDFUNC = C_ETL.CDFUNC;
                EXCEPTION
                     WHEN OTHERS THEN
                          V_QTERROCCLIENTE := 0;   
              END;


              BEGIN    
                    SELECT COUNT(*)
                      INTO V_QTERROCTESTE --QNTDE DE ERRO CONCLUDO NO TESTE
                      FROM PLANATIVTARE PL, TAREFA T, OPERADOR OP--, FUNCIONARIO FU
                     WHERE TRUNC(PL.DTCONATIVTAR) BETWEEN V_DTINI AND V_DTFIM
                       AND IDSITATIVTAR     = 'C'
                       AND PL.CDFILIAL      = T.CDFILIAL
                       AND PL.NRTAREFA      = T.NRTAREFA
                       AND PL.CDFILIAL   (+)= C_ETL.CDFILIAL
                       AND PL.CDOPERRESP (+)= C_ETL.CDOPERRESP
                       AND PL.CDPROCESSO (+)= C_ETL.CDPROCESSO
                       AND (PL.CDPROCESSO   = 10706 OR PL.CDPROCESSO = 10712)
                       AND T.NRSOLISERV  (+)= C_ETL.NRSOLISERV
                       AND T.CDASSUNTO   (+)= C_ETL.CDASSUNTO
                       AND OP.CDFUNC = C_ETL.CDFUNC;
                 EXCEPTION
                      WHEN OTHERS THEN
                           V_QTERROCTESTE := 0;
              END;
              
              BEGIN
                SELECT
                      SUM(TRUNC(TO_NUMBER(DTHFAPATIVTA - DTHIAPATIVTA)*60*24)),
                      SUM(TRUNC(TO_NUMBER(DTFIPATIVTAR - DTINPATIVTAR)*60*24))
                INTO
                      V_QTAPROP,
                      V_QTPLANE
                FROM
                      APROATIVTARE A,
                      PLANATIVTARE P
                WHERE
                      A.CDFILIAL     = P.CDFILIAL
                  AND A.NRTAREFA     = P.NRTAREFA
                  AND A.NRPLATIVTARE = P.NRPLATIVTARE
                  AND P.CDOPERRESP   = C_ETL.CDOPERRESP
                  AND P.CDFILIAL     = C_ETL.CDFILIAL
                  AND P.NRTAREFA     = C_ETL.NRTAREFA
                  AND ((DTHIAPATIVTA BETWEEN V_DTINI AND V_DTFIM)
                     OR(DTINPATIVTAR BETWEEN V_DTINI AND V_DTFIM));
            EXCEPTION
                 WHEN OTHERS THEN
                      V_QTAPROP := 0;
                      V_QTPLANE := 0;
              END;
              
              
              
              V_QTERROCTOTAL := V_QTERROCCLIENTE + V_QTERROCTESTE;  --QT TOTAL DE ERRO CONCLUDO (CLIENTE + TESTE)
              V_DTMES  :=  TO_CHAR(V_DTFIM,'MM');
              V_DTANO  :=  TO_CHAR(V_DTFIM,'YYYY');
              V_BIM := TRUNC ((V_DTMES - 1) / 2) + 1;
              V_TRI := TRUNC ((V_DTMES - 1) / 3) + 1;
              V_SEM := TRUNC ((V_DTMES - 1) / 6) + 1;
              V_CLIENTE := C_ETL.CDCLIENTE;


              IF (V_QTTOTALATIVOPER > 0) THEN
                 V_PERCERRO := V_QTERROCTOTAL / V_QTTOTALATIVOPER * 100;
              ELSE
                 V_PERCERRO := 0;
              END IF;

              
              IF C_ETL.CDCLIENTE IS NULL THEN
                 V_CLIENTE := 'J26269316000177';
              END IF; 
              V_NRRESULTDES := V_NRRESULTDES + 1;
              
              INSERT INTO ETLRESULTDES
                   (NRRESULTDES,           CDOPERADOR,          NRSOLISERV, 
                   CDPROCESSO,             CDASSUNTO,           CDCLIENTE,
                   CDEQUIPETRAB,           ANRESULTDES,         MERESULTDES, 
                   BIRESULTDES,            TRRESULTDES,         SERESULTDES, 
                   QTHRAPRESDES,           QTHRPlRESDES,        QTERROCCLIENTE,
                   QTERROCTESTE,           QTTOTATIV,           QTTOTERROCONC,
                   VRPERCERRO)
              VALUES
                    (TO_CHAR(V_NRRESULTDES),        C_ETL.CDOPERRESP,    C_ETL.NRSOLISERV, 
                    C_ETL.CDPROCESSO,      C_ETL.CDASSUNTO,     C_ETL.CDCLIENTE,
                    C_ETL.CDEQUIPETRAB,    V_DTANO,             V_DTMES, 
                    (V_BIM || ' Bim'),    (V_TRI || ' TRI'),  ( V_SEM || ' Sem'),  
                    V_QTAPROP,             V_QTPLANE,           V_QTERROCCLIENTE,
                    V_QTERROCTESTE,        V_QTTOTALATIV,       V_QTERROCTOTAL,
                    V_PERCERRO);
          END LOOP;
          COMMIT;   
          V_DTINI := ADD_MONTHS(V_DTINI,1);
    END LOOP;
END;
/
-- VERSAO --
BEGIN ATUVEROBJ('ETL_RESULTDES','0.00.000'); END;
/

