var CrosstabController = (function(_super) {
	__extends(CrosstabController1, _super);

	function CrosstabController1($scope, $rootScope, $timeout, ScreenService, templateManager, ZHPromise, eventEngine, Query, CrosstabService, $filter, maskEngine, ZhUtil, $window, ApplicationContext, ZhFeatures, eventAggregator) {
		var _ref = CrosstabController.__super__.constructor.apply(this, arguments);

		// BEGIN: Initialize
		var self = this;
		var CONTROLLER_KEY = 'CrosstabControllerInit';
		var ALL_DATA = 999999999;

		var methodsToLoad = {
			"afterLoadDataSource": function() {
				reloadCrosstabDataSource();
			}
		};

		Util.initializeComponent(this.widget, CONTROLLER_KEY, methodsToLoad, undefined, eventEngine);
		// END: Initialize

		// Floating Control defaults
		var floatingControlDefaults = {
			pdfAction: false,
			xlsAction: false,
			csvAction: false,
			customizationAction: {
				filter: true,
				layout: false,
				view: false
			}
		};
		self.updateFloatingControlDefaults(floatingControlDefaults);

		this.search = function(crosstabRow) {
			$scope.widget.searchCriteria = $scope.widget.searchCriteria || {};
			self.widget.searchList = $scope.widget.searchCriteria._ALL;
			var rowVisibility = true;
			if (Util.objectHasAnyValue($scope.widget.searchCriteria)) {
				var filterConfig = {
					ignoreUnexistentFields: true
				};
				Object.keys(crosstabRow).some(function (rowProperty) {
					if (Util.objectHasAnyValue(crosstabRow[rowProperty])) {
						rowVisibility = self.checkRowVisibilityFromCriteria(crosstabRow[rowProperty], $scope.widget.searchCriteria, filterConfig);
					}
					return rowVisibility;
				});
			}
			crosstabRow.__notSelectable = !rowVisibility;
			return rowVisibility;
		};

		var reloadCrosstabDataSource = Util.buildDebounceMethod(function() {
			if (self.isCrosstab(self.widget)) {
				self.widget.crosstabData = [];
				if (self.widget.dataSource && self.widget.dataSource.data) {
					self.widget.crosstabData = CrosstabService.build(self.widget, self.widget.dataSource.data);
					templateManager.updateTemplate();
				}
			}
		}, 100);

		$scope.$watch('widget', reloadCrosstabDataSource);
		$scope.$watchCollection('widget.dataSource.data', reloadCrosstabDataSource);

		var _widget = self.widget;
		$scope.$on('$destroy', function() {
			delete _widget.crosstabData;
		});

		return _ref;
	}

	return CrosstabController1;
})(GridController);